<template>

  <v-dialog
    max-width="620" v-model="dialogo"
    transition="fab-transition" persistent
  >

    <v-card style="border-radius: 10px;" class="pa-6" elevation="0" outlined>

      <v-toolbar elevation="0" color="transparent" dense>

        <v-spacer />
        <v-toolbar-title class="text-h5"> {{ grado.idGrado > 0 ? 'Editar' : 'Nuevo' }} Grado</v-toolbar-title>
        <v-spacer />
        <v-btn icon @click.stop="CerrarDialogo">
          <v-icon size="30"> mdi-close </v-icon>
        </v-btn>

      </v-toolbar>

      <v-card-text class="pa-4">

        <v-form ref="frmGrado">

          <v-text-field
            name="Grado-text" label="Nombre" v-model="grado.nombre"
            style="border-radius: 10px;" :rules="[rules.nombre.required]"
            prepend-inner-icon="mdi-format-text" outlined
            color="white"
          />

          <v-select
            v-model="grado.idProfesor" :items="profesores" item-value="idProfesor"
            item-text="nombre" style="border-radius: 10px;"
            prepend-inner-icon="mdi-gender-male" label="Profesor Encargado"
            :rules="[rules.profesor.required]" outlined
            color="white"
          >

            <template v-slot:item="{ on, attrs, item }">
              <v-list-item v-on="on" v-bind="attrs">
                <v-list-item-content>
                  <v-list-item-title>{{ item.nombre + ' ' + item.apellidos }}</v-list-item-title>
                </v-list-item-content>
              </v-list-item>
            </template>

          </v-select>

          <v-btn
            color="amber darken-2" light block style="border-radius: 10px;"
            elevation="0" x-large @click="ActualizarGrado"
            dark v-if="grado.idGrado > 0"
          >
            <v-icon left dark size="25"> mdi-check </v-icon>
            Actualizar Grado
          </v-btn>

          <v-btn
            color="blue darken-1" light block style="border-radius: 10px;"
            elevation="0" x-large @click="GuardarGrado"
            dark v-else
          >
            <v-icon left dark size="25"> mdi-check </v-icon>
            Guardar Grado
          </v-btn>

        </v-form>

      </v-card-text>

    </v-card>

  </v-dialog>

</template>

<script>

export default {

  props: {
    value: Boolean,
    grado: Object,
    profesores: Array
  },

  computed: {

    dialogo: {

      get(){
        return this.value
      },
      set(value){
        this.$emit('input', value)
      }

    }

  },

  data(){

    return {

      menu: false,

      generos: [
        { texto: "Masculino", valor: "M" },
        { texto: "Femenino", valor: "F" }
      ],

      rules: {

        nombre: { required: v => !!v || "El nombre es obligatorio" },

        profesor: { required: v => !!v || "El género es obligatorio" }

      }

    }

  },

  methods: {

    async GuardarGrado(){

      let config = { timeout: 5000 }

      await this.$axios.post("/grados", this.grado, config).then(({data}) => {

        this.$emit("refresh");
        this.CerrarDialogo()

      })

    },

    async ActualizarGrado(){

      let config = { timeout: 5000 }

      await this.$axios.post("/grados/" + this.grado.idGrado, this.grado, config).then(({data}) => {

        this.$emit("refresh");
        this.CerrarDialogo()

      })

    },

    CerrarDialogo(){

      this.$emit("update:grado", {})
      this.$refs.frmGrado?.resetValidation()
      this.dialogo = false

    }

  }


}

</script>
